/* Speichern der Konfigurationstabelle mit minimaler Zahl von Bytes 
 * auch auf Platte (v1.4.1 Jan00) 40er sollte nun auf 4GB-Rechner gehen
 */
#include "tbase.h"
#include "error.h"
#include <stdlib.h>
#include <stdio.h>

unsigned char *l1;			/* tbase *l1 - until Jan00 */
FILE *fl1=NULL;


/* 40 spins cross the 1GB file limit => problems??? ofs=file_ofs */
int save_l1(unsigned char *l1, ULong n1, ULong ofs){
  FILE *f1=NULL; size_t t1;
  if(vvv && ofs==0)printf(" write_%s (Bsize=%d)",FILE_l1,(int)Bsize);
  if(vvv) printf(" (%lu) +%lu",(unsigned long)ofs,(unsigned long)n1);
  if (!n1) return 0;
  f1=fopen(FILE_l1,"r+b");
  if (!f1) f1=fopen(FILE_l1,"wb");
  if(!f1) { E1("fopen_%s",FILE_l1); return -1; }	/* error */
  if((double)((long)n1 *Bsize)!=((double)n1 )*Bsize)E0("l1: n1-OVL");
  if((double)((long)ofs*Bsize)!=((double)ofs)*Bsize)E0("l1: ofs-OVL");
  if (fseek(f1,(long)ofs*Bsize,SEEK_SET)) E0("fseek");
  t1=ftell(f1); if(t1!=ofs*Bsize) E0("ftell!=fseek");
  t1=fwrite(l1,Bsize,n1,f1); 
  if(t1!=n1){ ERR(510); l1+=t1*Bsize; n1-=t1; t1=fwrite(l1,Bsize,n1,f1); }
  if(t1!=n1){ ERR(510); }
  fclose(f1);
  return 0;
}

int load_l1(unsigned char *l1, ULong n1){
  FILE *f1=NULL; size_t t1;
  if(vvv)printf(" load_%s size*%d",FILE_l1,(int)Bsize);
  f1=fopen(FILE_l1,"rb");
  if(!f1) { E1("fopen_%s",FILE_l1); return -1; }	/* error */
  if((double)((long)n1*Bsize)!=((double)n1)*Bsize)E0("long-OVL");
  t1=fread(l1,Bsize,n1,f1);
  if(t1!=n1){ ERR(510); l1+=t1*Bsize; n1-=t1; t1=fread(l1,Bsize,n1,f1); }
  if(t1!=n1){ ERR(510); err_fatal=510; }
  fclose(f1);
  return 0;
}

tbase getl1(ULong i){	/* use b=next(b) for b=getl1(i++) if possible */
 tbase t1; unsigned int j;
#if 0 && defined(LHsystem) 		/* low-high byteorder, much faster */
/* DEC-wildfire: unaligned access (signal=meldung=slow-down), aber ergebnis korrekt */
   return (*(tbase *)(l1+i*Bsize))
   & ~((~(tbase)0)<<(8*(Bsize-1))<<8); /* (64bit)1l<<64 nicht spezifiziert! */
#else
   for(t1=0l,j=0;j<Bsize;j++) t1|=((tbase)l1[i*Bsize+j])<<(8*j);
   return t1; 
#endif
}

void putl1(ULong i, tbase kfg, unsigned char *l1){
 unsigned int j;
 for(j=0;j<Bsize;j++) l1[i*Bsize+j] = (unsigned char)(255 & kfg>>(8*j));
}
